# Python
import evolutionaryCats as cats
import time
import gym
import os

def init():

    # Create enviroment
    env = gym.make('CartPole-v0')

    # Episodes
    max_episodes = 10000000

    # Algorithm settings
    action_space = [0, 1]
    population_size = 50
    genes_in_genom = 4
    elite_alives = 10
    random_genomes = 0
    mutation_rate = 0.2
    mutation_step = 0.1

    # Best score
    best_score = 0

    # Create genetic enviroment
    _cats = cats.newCats(
                            action_space, # Action space
                            population_size, # Population_size
                            genes_in_genom, # Genes num
                            elite_alives, # Elites
                            mutation_rate, # Rate
                            mutation_step, # Step
                            random_genomes # Random genes in new population
                        )

    # Episodes Loop
    for episode in range(1, max_episodes):
        # Iterate through genomes
        for gen in range(population_size):
            os.system('cls')
            print('Population {}\nGenome {}/{}\nBest reward {}\nGenes {}\nReward 0'.format(episode, gen, population_size, best_score, _cats.cuddleCat().genes), end='')
            # Reset enviroment
            observation = env.reset()
            # Set our "cat" to genome number
            _cats.setCurrentCat(gen)
            # Done?
            done = False
            # Reward for genome
            total_reward = 0
            # Game loop
            while done == False:
                env.render()
                action = _cats.action(env)
                observation, reward, end, _ = env.step(action)
                total_reward += reward
                if reward > 0:
                    _cats.addPoint()
                    if total_reward % 10 == 0:
                        print('\rReward {}'.format(total_reward), end='')

                if reward == 0:
                    best_score = total_reward if total_reward > best_score else best_score
                    _cats.genomeGameOver()
                    done = True

        _cats.nextPopulation()



if __name__ == '__main__':
    init()
